let lock = false;
import { alertOnce } from './xFetch';

export default async function login() {
  if (lock == true) {
    await waitLockRelease(50);

    return;
  }
  lock = true;
  return new Promise((resolve, reject) => {
    dd.getAuthCode({
      success: function (res) {
        // 获取用户信息
        dd.httpRequest({
          headers: {
            "Content-Type": "application/json",
            "Authorization": `Basic bWVldGluZy13ZWI6bWVldGluZy13ZWI=`
          },
          url: `${getApp().globalData.globalUrl}/admin/skipAuth/getUserInfoByDingtalkCode?orgId=${dd.corpId}&projectName=MING_MEETING&code=${res.authCode}`,
          method: 'POST',
          dataType: 'json',
          success: function (res) {
            console.log(res)
            if (res.data.code == 0) {
              const { oapiUser } = res.data.data;
              getApp().globalData.token = res.data.data.accessToken.access_token;
              getApp().globalData.name = res.data.data.oapiUser.name;
              getApp().globalData.avatar = res.data.data.oapiUser.avatar;
              getApp().globalData.userid = res.data.data.oapiUser.userid;
              getApp().globalData.mwUserId = res.data.data.mwUserId;
              dd.setStorageSync({
                key: 'mwUserId', data: res.data.data.mwUserId,
                key: 'userid', data: res.data.data.oapiUser.userid,
                key: 'userInfo', data: {
                  username: oapiUser.name,
                  avatar: oapiUser.avatar,
                  userId: oapiUser.userid
                }
              })
              getApp().globalData.avatar = res.data.data.oapiUser.avatar;
              getApp().globalData.userInfo = JSON.stringify({
                username: oapiUser.name,
                avatar: oapiUser.avatar,
                userId: oapiUser.userid,
                headUrl: oapiUser.avatar,
                platform: "dingtalk"
              });
              lock = false;
              resolve(res)
            } else if (res.data.code == 10200) {
              lock = false;
              alertOnce('应用正在开通中，请稍后再试', reject, { ...res.data, code: 10200 });
              reject(res.data);
            } else {
              lock = false;
              reject(res.data);
            }
          },
          fail: function (err) {
            lock = false;
            reject(err);
          }
        })
      },
      fail: function (err) {
        lock = false;
        reject(err);
      }
    })
  })
}
async function waitLockRelease(retry) {
  for (let i = 0; i < retry; i++) {
    if (lock == false) {
      return;
    }
    await sleep(100);
  }
}

function sleep(time) {
  return new Promise(resolve => {
    setTimeout(resolve, time);
  });
}
